"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComponentTree = void 0;
const react_1 = __importStar(require("react"));
const base_ui_graph_tree_tree_context_1 = require("@teambit/base-ui.graph.tree.tree-context");
const base_ui_graph_tree_indent_1 = require("@teambit/base-ui.graph.tree.indent");
const base_ui_graph_tree_inflate_paths_1 = require("@teambit/base-ui.graph.tree.inflate-paths");
const base_ui_graph_tree_recursive_tree_1 = require("@teambit/base-ui.graph.tree.recursive-tree");
const base_ui_graph_tree_root_node_1 = require("@teambit/base-ui.graph.tree.root-node");
const payload_type_1 = require("./payload-type");
const default_tree_node_renderer_1 = require("./default-tree-node-renderer");
function ComponentTree({ components, onSelect, selected, TreeNode = default_tree_node_renderer_1.DefaultTreeNodeRenderer, }) {
    const rootNode = react_1.useMemo(() => {
        const tree = base_ui_graph_tree_inflate_paths_1.inflateToTree(components, (c) => c.id.toString({ ignoreVersion: true }));
        const payloadMap = calcPayload(components);
        base_ui_graph_tree_inflate_paths_1.attachPayload(tree, payloadMap);
        return tree;
    }, [components]);
    return (react_1.default.createElement("div", { style: base_ui_graph_tree_indent_1.indentStyle(1) },
        react_1.default.createElement(base_ui_graph_tree_recursive_tree_1.TreeNodeContext.Provider, { value: TreeNode },
            react_1.default.createElement(base_ui_graph_tree_tree_context_1.TreeContextProvider, { onSelect: onSelect, selected: selected },
                react_1.default.createElement(base_ui_graph_tree_root_node_1.RootNode, { node: rootNode, depth: 1 })))));
}
exports.ComponentTree = ComponentTree;
function calcPayload(components) {
    const payloadMap = new Map(components.map((c) => [c.id.toString({ ignoreVersion: true }), c]));
    const scopeIds = new Set(components.map((x) => x.id.scope).filter((x) => !!x));
    scopeIds.forEach((x) => x && payloadMap.set(`${x}/`, new payload_type_1.ScopePayload()));
    return payloadMap;
}
//# sourceMappingURL=component-tree.js.map