"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComponentView = void 0;
const ui_react_router_nav_link_1 = require("@teambit/ui.react-router.nav-link");
const ui_env_icon_1 = require("@teambit/ui.env-icon");
const ui_deprecation_icon_1 = require("@teambit/ui.deprecation-icon");
const clickable_1 = require("bit-bin/dist/to-eject/css-components/clickable");
const classnames_1 = __importDefault(require("classnames"));
const react_1 = __importStar(require("react"));
const react_tooltip_1 = __importDefault(require("react-tooltip"));
const component_1 = require("@teambit/component");
const base_ui_graph_tree_tree_context_1 = require("@teambit/base-ui.graph.tree.tree-context");
const base_ui_graph_tree_indent_1 = require("@teambit/base-ui.graph.tree.indent");
const get_name_1 = require("../utils/get-name");
const component_view_module_scss_1 = __importDefault(require("./component-view.module.scss"));
function ComponentView(props) {
    var _a;
    const { node } = props;
    const component = node.payload;
    const { onSelect } = react_1.useContext(base_ui_graph_tree_tree_context_1.TreeContext);
    const handleClick = react_1.useCallback((event) => {
        onSelect && onSelect(node.id, event);
    }, [onSelect, node.id]);
    if (!(component instanceof component_1.ComponentModel))
        return null;
    const componentId = `sidebar-${component.id.toString()}`;
    return (react_1.default.createElement(ui_react_router_nav_link_1.NavLink, { href: `/${component.id.fullName}`, className: classnames_1.default(base_ui_graph_tree_indent_1.indentClass, clickable_1.clickable, component_view_module_scss_1.default.component), activeClassName: component_view_module_scss_1.default.active, onClick: handleClick },
        react_1.default.createElement("div", { className: component_view_module_scss_1.default.left },
            react_1.default.createElement(ui_env_icon_1.EnvIcon, { component: component, className: component_view_module_scss_1.default.envIcon, "data-tip": "", "data-for": componentId }),
            react_1.default.createElement("span", null, get_name_1.getName(node.id)),
            react_1.default.createElement("div", { className: "--ssr-hidden" },
                react_1.default.createElement(react_tooltip_1.default, { place: "bottom", id: componentId, effect: "solid" },
                    react_1.default.createElement("div", { className: component_view_module_scss_1.default.componentEnvTooltip },
                        react_1.default.createElement("div", { className: component_view_module_scss_1.default.componentEnvTitle }, "Environment"),
                        react_1.default.createElement("div", { className: component_view_module_scss_1.default.componentEnv }, (_a = component.environment) === null || _a === void 0 ? void 0 : _a.id))))),
        react_1.default.createElement("div", { className: component_view_module_scss_1.default.right },
            react_1.default.createElement(ui_deprecation_icon_1.DeprecationIcon, { component: component }),
            props.treeNodeSlot &&
                props.treeNodeSlot.toArray().map(([id, treeNode]) => react_1.default.createElement(treeNode.widget, { key: id, component: component })))));
}
exports.ComponentView = ComponentView;
//# sourceMappingURL=component-view.js.map